// Store a copy Downloadwith Preference
function objDwPreference () {
	///////////// Private variables /////////////
	var application = new Array();
	var autoDownloadStatus;
	var autoDownloadApplication;
	var showUrl;

	///////////// Public constants /////////////
	this.IDENT = 0;
	this.LABEL = 1;
	this.COMMAND = 2;
	this.ARGS = 3;

	///////////// Private Methods /////////////
	function addApplication(identification,label,command,arguments) {
		application.push([identification,label,command,arguments]);
	}
	

	///////////// Public Methods /////////////
	this.getFirstApplication = function (){
		currentApplication = 0;
		return this.getNextApplication();
	}
	
	this.getNextApplication = function (){
		retval = null;
		if ( currentApplication < application.length) {
			retval = application[currentApplication];
			currentApplication = currentApplication + 1;
		}
		return retval;
	}
	
	this.getApplication = function (identification) {
		for (var i = 0; i < application.length; i++) {
			if (application[i][this.IDENT]==identification) return application[i];
		}
		return null;
	}

	this.showContextMenuURL = function () {
		return showUrl;
	}

	this.reset = function () {
		try { autoDownloadStatus = dwPrefService.getAutoDownloadStatus(); }
		catch (e) { 
			dwPrefService.setAutoDownloadStatusDisable();
			autoDownloadStatus = dwPrefService.getAutoDownloadStatus();  
		}
		try { autoDownloadApplication = dwPrefService.getAutoDownloadAllApplication(); }
		catch (e) {
			dwPrefService.setAutoDownloadAllApplication("");
			autoDownloadApplication = dwPrefService.getAutoDownloadAllApplication();
		}
		try { showUrl = dwPrefService.getContextMenuShowUrl(); }
		catch (e) { 
			dwPrefService.setContextMenuShowUrl(false); 
			showUrl = dwPrefService.getContextMenuShowUrl();
		}
		application = new Array();
		try {
			var identification = dwPrefService.getIdentificationArray();
			for (var i = 0; i < identification.length; i++) {
				if (identification[i] != null && identification[i] != "" ) 
					addApplication( identification[i],
						          dwPrefService.getApplicationLabel(identification[i]),
						          dwPrefService.getApplicationCommand(identification[i]),
						          dwPrefService.getApplicationArguments(identification[i]));
			}
		} catch (e) {
			if (window.navigator.platform.toLowerCase().indexOf("win") != -1) {
				/* windows */
				dwPrefService.addApplication("getright","GetRight","C:\\Program Files\\GetRight\\getright.exe","[URL]");
			} else {
				/* unix, linux and others */
				dwPrefService.addApplication("wget","wget","/usr/X11R6/bin/xterm","-hold -T wget -e wget -P ~ [URL]");
			}
			var identification = dwPrefService.getIdentificationArray();
			for (var i = 0; i < identification.length; i++) {
				if (identification[i] != null && identification[i] != "" ) 
					addApplication( identification[i],
						          dwPrefService.getApplicationLabel(identification[i]),
						          dwPrefService.getApplicationCommand(identification[i]),
						          dwPrefService.getApplicationArguments(identification[i]));
			}
		}
	}
}