// Global functions
function objDwUtil()
{
	this.error = function(msg) { alert("DownloadWith: " + msg);	}
	
	this.execCommand = function(command,strArgs) {
		// separate command arguments
		var args = new Array();
		var quoted = false;
		var double_quoted = false;
		var param = "";
		for (var i = 0; i < strArgs.length; i++) { 
			var charArgs = strArgs.substring(i,i + 1);
			if ( charArgs == "\""  && !quoted ) { double_quoted =! double_quoted; }
			else if ( charArgs == "\'" && !double_quoted ) { quoted =! quoted; } 
			else if ( /\s/.test(charArgs) && !quoted && !double_quoted ) {
				if (param != "") args.push( param );
			param = "";
			} else param += charArgs;	
		}
		if (param != "") args.push( param );
		// create a file object for the external program
		try {
			var applicFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			var applic = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
			applicFile.initWithPath(command);
			if (! applicFile.exists()) {
				this.error("Executable '" + command + "' does not exist.");
			} else {
				applic.init(applicFile);
				applic.run(false, args, args.length);
			}
		} catch (e) {
			this.error("Cannot run executable: " + e);
			return false;
		}
	}

	this.getFileType = function (url) {
		var aux = url.split("/").pop().split(".");
		if (aux.length > 1) return (aux[aux.length - 1].toLowerCase());
		return "";
	}

	this.enableElement = function(element) { element.removeAttribute("disabled"); }

	this.disableElement = function(element) { element.disabled = "true"; }

	this.showElement = function(element) { element.removeAttribute("hidden"); }

	this.hiddenElement = function(element) { element.setAttribute("hidden","true"); }
}